/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.main.ConfigManager
 *  fire.pb.skill.SPetSkillitem
 *  fire.pb.skill.SPetSkillupgrade
 *  fire.pb.skill.SSkillConfig
 */
package fire.pb.pet;

import fire.pb.main.ConfigManager;
import fire.pb.pet.Module;
import fire.pb.pet.PetAttr;
import fire.pb.pet.SShenShouInc;
import fire.pb.skill.SPetSkillitem;
import fire.pb.skill.SPetSkillupgrade;
import fire.pb.skill.SSkillConfig;
import java.util.ArrayList;
import java.util.Map;
import java.util.NavigableMap;
import java.util.TreeMap;

public class PetManager {
    NavigableMap<Integer, PetAttr> petAttrConfigMap = new TreeMap<Integer, PetAttr>();
    NavigableMap<Integer, ArrayList<SShenShouInc>> shenshouIncConfigMap = new TreeMap<Integer, ArrayList<SShenShouInc>>();
    ArrayList<PetAttr> shenshouAttrConfigList = new ArrayList();

    public static PetManager getInstance() {
        return SingletonHolder.singleton;
    }

    private PetManager() {
        this.reload();
    }

    public void reload() {
        this.petAttrConfigMap = ConfigManager.getInstance().getConf(PetAttr.class);
        TreeMap shenshouInc = ConfigManager.getInstance().getConf(SShenShouInc.class);
        for (Map.Entry entry : shenshouInc.entrySet()) {
            int petId = ((SShenShouInc)entry.getValue()).getPetid();
            if (!this.shenshouIncConfigMap.containsKey(petId)) {
                this.shenshouIncConfigMap.put(petId, new ArrayList());
            }
            ArrayList listShenShouInc = (ArrayList)this.shenshouIncConfigMap.get(petId);
            listShenShouInc.add(entry.getValue());
        }
        for (PetAttr pa : this.petAttrConfigMap.values()) {
            if (pa.getKind() != 4) continue;
            this.shenshouAttrConfigList.add(pa);
        }
        if (Module.logger.isInfoEnabled()) {
            Module.logger.info((Object)("PetAttr load size=" + this.petAttrConfigMap.size()));
        }
    }

    public PetAttr getAttr(int petId) {
        return (PetAttr)this.petAttrConfigMap.get(petId);
    }

    public SPetSkillupgrade getSkillUpGrade(int skillId) {
        TreeMap map = ConfigManager.getInstance().getConf(SPetSkillupgrade.class);
        if (map != null) {
            return (SPetSkillupgrade)map.get(skillId);
        }
        return null;
    }

    public int getSkillScore(int skillId) {
        SPetSkillitem skillItem = (SPetSkillitem)ConfigManager.getInstance().getConf(SPetSkillitem.class).get(skillId);
        if (skillItem != null) {
            return skillItem.getScore();
        }
        return 0;
    }

    public boolean isActiveSkill(int skillId) {
        SSkillConfig cfg = (SSkillConfig)ConfigManager.getInstance().getConf(SSkillConfig.class).get(skillId);
        if (cfg == null) {
            return false;
        }
        return cfg.isActive;
    }

    public PetAttr randGetOneShenShou() {
        int randIndex = (int)(Math.random() * (double)this.shenshouAttrConfigList.size());
        return this.shenshouAttrConfigList.get(randIndex);
    }

    public final SShenShouInc getShenShouIncConfig(int petId, int hasIncCount) {
        ArrayList incInfo = (ArrayList)this.shenshouIncConfigMap.get(petId);
        for (SShenShouInc sShenShouInc : incInfo) {
            if (sShenShouInc.getInccount() != hasIncCount + 1) continue;
            return sShenShouInc;
        }
        return null;
    }

    public boolean isPetLifeForever(int petId) {
        PetAttr petAttr = this.getAttr(petId);
        return petAttr != null && petAttr.getLife() == -1;
    }

    static class SingletonHolder {
        static PetManager singleton = new PetManager();

        SingletonHolder() {
        }
    }
}

